#include <p24fj128ga010.h>

_CONFIG2( FCKSM_CSDCMD & OSCIOFNC_ON & POSCMOD_HS & FNOSC_PRI )

#define SYSCLK       8000000
#define BAUDRATE2    9600
#define BAUDRATEREG  SYSCLK /8 / BAUDRATE2-1

#define UART2_TX_TRIS   TRISFbits.TRISF5
#define UART2_RX_TRIS   TRISFbits.TRISF4

void UART2Init()
{
  UART2_TX_TRIS = 0;
  UART2_RX_TRIS = 1;
  U2BRG = BAUDRATEREG;
  U2MODE = 0;
  U2MODEbits.BRGH = 1;
  U2MODEbits.UARTEN = 1;

  U2STA = 0;
  U2STAbits.UTXEN = 1;
  IFS1bits.U2RXIF = 0;
}
void  UART2PutChar(char Ch)
{

  while(U2STAbits.UTXBF == 1);
  U2TXREG = Ch;
}

void Delay(void)
{
 long del = 1000;
 while (del != 0) del--;
}

void main()
{
  char *s1 = "RS-485 Test String from PIC24";
  TRISD = 0;
  _RD0 = 1;

  UART2Init();
  Delay();
  while (*s1 != '\0')
   {
    UART2PutChar(*s1++);
    Delay();
   }
  while (1)
  {
  }
}
