#include <p24fj128ga010.h>
#include <stdio.h>

_CONFIG2( FCKSM_CSDCMD & OSCIOFNC_ON & POSCMOD_HS & FNOSC_PRI )

#define SYSCLK        8000000
#define BAUDRATE2     9600
#define BAUDRATEREG   SYSCLK /8 / BAUDRATE2-1

#define t1            3
#define PREG          SYSCLK / 2 / 256 * t1

#define UART2_TX_TRIS   TRISFbits.TRISF5
#define UART2_RX_TRIS   TRISFbits.TRISF4

void UART2Init()
{
  UART2_TX_TRIS = 0;
  UART2_RX_TRIS = 1;
  U2BRG = BAUDRATEREG;
  U2MODE = 0;
  U2MODEbits.BRGH = 1;
  U2MODEbits.UARTEN = 1;
  U2STA = 0;
  U2STAbits.UTXEN = 1;
  IFS1bits.U2RXIF = 0;
}

void  UART2PutChar(char Ch)
{
  while(U2STAbits.UTXBF == 1);
  U2TXREG = Ch;
}

char tmp;
char buf[32];
int i1, bytes;

void __attribute__ ((__interrupt__)) _T1Interrupt(void)
{
  _T1IF = 0;
  tmp = PORTA;
  bytes = sprintf(buf, "0x%X ", tmp);
  for (i1 = 0; i1 < bytes; i1++)
  UART2PutChar(buf[i1]);
}

void main()
{
  TRISA = 0xffff;
  UART2Init();
  _T1IF = 0;
  _T1IE = 1;

  PR1 = PREG;
  TMR1 = 0;
  T1CON = 0x8030;

  while (1)
   {
   }
}
