#include <p24fj128ga010.h>

_CONFIG2( FCKSM_CSDCMD & OSCIOFNC_ON & POSCMOD_HS & FNOSC_PRI )

#define SYSCLK       8000000
#define BAUDRATE2    9600
#define BAUDRATEREG  SYSCLK /8 / BAUDRATE2-1

#define UART2_TX_TRIS   TRISFbits.TRISF5
#define UART2_RX_TRIS   TRISFbits.TRISF4

#define t1 0.5
#define PREG  SYSCLK /2 /256 * t1

#define XON  17
#define XOFF 19

void UART2Init()
{
  UART2_TX_TRIS = 0;
  UART2_RX_TRIS = 1;
  U2BRG = BAUDRATEREG;

  U2MODE = 0;
  U2MODEbits.BRGH = 1;
  U2MODEbits.UARTEN = 1;
  U2STA = 0;
  U2STAbits.UTXEN = 1;
  IFS1bits.U2RXIF = 0;
}

void  UART2PutChar(char Ch)
{
  while(U2STAbits.UTXBF == 1);
  U2TXREG = Ch;
}

char *str1 = "Testing XON/XOFF Flow control";
char Temp;
char Stop = 0;

void __attribute__ ((__interrupt__)) _T1Interrupt(void)
{
  _T1IF = 0;
  if (Stop == 0)
   {
    if (*str1 != 0)
    UART2PutChar(*str1++);
   }
}

void __attribute__ ((__interrupt__)) _U2RXInterrupt(void)
{
  _U2RXIF = 0;
  Temp = U2RXREG;
  if (Temp == XOFF)
   Stop = 1;
  if (Temp == XON)
   Stop = 0;
}

void main()
{

  UART2Init();
  _U2RXIF = 0;
  _U2RXIE = 1;

  _T1IF = 0;
  _T1IE = 1;

  PR1 = PREG;
  TMR1 = 0;
  T1CON = 0x8030;

  while (1)
  {
  }
}

