#include <p24fj128ga010.h>

_CONFIG2( FCKSM_CSDCMD & OSCIOFNC_ON & POSCMOD_HS & FNOSC_PRI )

#define SYSCLK        8000000
#define BAUDRATE2     9600
#define BAUDRATEREG   SYSCLK /8 / BAUDRATE2-1

#define UART2_TX_TRIS   TRISFbits.TRISF5
#define UART2_RX_TRIS   TRISFbits.TRISF4

void UART2Init()
{
  UART2_TX_TRIS = 0;
  UART2_RX_TRIS = 1;
  U2BRG = BAUDRATEREG;

  U2MODE = 0;
  U2MODEbits.UEN1 = 1;
  U2MODEbits.BRGH = 1;

  U2MODEbits.UARTEN = 1;
  U2STA = 0;
  U2STAbits.UTXISEL0 = 1;
  U2STAbits.UTXEN = 1;
  IFS1bits.U2RXIF = 0;
}

char *str = "RTS/CTS Flow Control test";

void __attribute__ ((__interrupt__)) _U2TXInterrupt(void)
{
 if (*str != 0)
  {
   U2TXREG = *str++;
   while(U2STAbits.UTXBF == 1);
  }
}

void main()
{

  UART2Init();
  _U2TXIF = 0;
  _U2TXIE = 1;
  U2TXREG = *(--str);

  while (1)
  {
  }
}
