unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    procedure FormActivate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure UART_init;

  private
    { Private declarations }
  public
    { Public declarations }
  end;

 type
  Thread1 = class(TThread)
  protected
    procedure Execute; override;
    procedure UpdateEdit;
 end;

const
 PORT1 = $3F8;
 BRH   = PORT1 + 1;
 FIFO  = PORT1 + 2;
 LCR   = PORT1 + 3;
 MCR   = PORT1 + 4;
 LSR   = PORT1 + 5;

var
  myThread: Thread1;
  Form1: TForm1;
  c1: Byte;
implementation

{$R *.dfm}
procedure TForm1.UART_init;
begin
 asm
  mov  DX, BRH
  xor  AL, AL
  out  DX, AL

  mov  DX, LR
  mov  AL, 80h
  out  DX, AL

  mov  DX, PORT1
  mov  AL, 0Ch
  out  DX, AL

  mov  DX, BRH
  xor  AL, AL
  out  DX, AL

  mov  DX, LCR
  mov  AL, 3h
  out  DX, AL

  mov  DX, FIFO
  xor  AL, AL
  out  DX, AL

  mov  DX, MCR
  out  DX, AL
 end;
end;

procedure Thread1.Execute;
begin
 while True do
  begin
   asm
     mov DX, LSR
    @again:
     in  AL, DX
     and AL, 1h
     cmp AL, 1
     jne @again
     mov DX, PORT1
     in  AL, DX
     mov c1, AL
   end;
     Synchronize(UpdateEdit);
  end;
end;

procedure Thread1.UpdateEdit;
begin
 Form1.Edit1.Text:= Form1.Edit1.Text + Char(c1);
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
 UART_init();
 Edit1.Text:= ' ';
 myThread:= Thread1.Create(False);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 Edit1.Text:= ' ';
end;

end.
