#include <stdio.h>
#include "windrvr.h"
#include "status_strings.h"

#define PORT1 0x3F8
#define LSR   PORT1 + 5

enum {
    MY_IO_BASE = 0x3F8,
    MY_IO_SIZE = 0x7
};

static HANDLE hWD;
static WD_CARD_REGISTER cardReg;

static BYTE IO_inp(DWORD dwIOAddr)
{
    WD_TRANSFER trns;
    BZERO(trns);
    trns.cmdTrans = RP_BYTE;
    trns.dwPort = dwIOAddr;
    WD_Transfer( hWD, &trns);
    return trns.Data.Byte;
}

static void IO_outp(DWORD dwIOAddr, BYTE bData)
{
    WD_TRANSFER trns;
    BZERO(trns);
    trns.cmdTrans = WP_BYTE;
    trns.dwPort = dwIOAddr;
    trns.Data.Byte = bData;
    WD_Transfer( hWD, &trns);
}

static BOOL IO_init(void)
{
    WD_VERSION verBuf;
    DWORD dwStatus;

    hWD = WD_Open();
    if (hWD==INVALID_HANDLE_VALUE)
    {
        printf("error opening WINDRVR\n");
        return FALSE;
    }

    BZERO(verBuf);
    WD_Version(hWD, &verBuf);
    printf(WD_PROD_NAME " version - %s\n", verBuf.cVer);
    if (verBuf.dwVer<WD_VER)
    {
        printf("error incorrect WINDRVR version. needs ver %d\n",WD_VER);
        WD_Close(hWD);
        return FALSE;
    }

    BZERO(cardReg);
    cardReg.Card.dwItems = 1;
    cardReg.Card.Item[0].item = ITEM_IO;
    cardReg.Card.Item[0].fNotSharable = TRUE;
    cardReg.Card.Item[0].I.IO.dwAddr = MY_IO_BASE;
    cardReg.Card.Item[0].I.IO.dwBytes = MY_IO_SIZE;
    cardReg.fCheckLockOnly = FALSE;
    dwStatus = WD_CardRegister(hWD, &cardReg);
    if (cardReg.hCard==0)
    {
        printf("Failed locking device. Status 0x%lx - %s\n",
            dwStatus, Stat2Str(dwStatus));
        WD_Close(hWD);
        return FALSE;
    }

    return TRUE;
}

static void IO_end(void)
{
    WD_CardUnregister(hWD,&cardReg);
    WD_Close(hWD);
}

int main(void)
{
   char buf[256];
   char *pbuf = buf;
   char c1;

   if (!IO_init())
        return -1;
    printf("Waiting for data...\n"); 
    while (1)
     {
      do {
          c1 = IO_inp(LSR) & 0x1;
         } while (c1 == 0);
     *pbuf = IO_inp(PORT1);
      printf("%c", *pbuf++);
     }

   IO_end();
   return 0;
}
